var fs = require('fs');
var toml = require('toml');
var PageList = require('./Page').PageList;
var Page = require('./Page').Page;
var moment = require('moment');
var path = require('path');

function walk(currentDirPath, callback, end_cb) {
  var subcalls = 0;
  var ender = function() {
    subcalls--;
    if(subcalls <= 0) {
      if(end_cb !== undefined)
        end_cb();
    }
  }
  var fs = require('fs'), path = require('path');
  fs.readdir(currentDirPath, function(err, files) {
    if(err!=null) console.log(err);
    files.forEach(function(name) {
      var filePath = path.join(currentDirPath, name);
      var stat = fs.statSync(filePath);
      if (stat.isFile()) {
        callback(filePath, stat);
      } else if (stat.isDirectory()) {
        if(filePath.indexOf(".git") < 0) {
          subcalls++;
          walk(filePath, callback, ender);
        }
      }
    });
    if(subcalls == 0) ender();
    
  });
};

var readPageWorker = function(file, articleName, contentDir) {
  if(file === undefined) throw new Error("file is undefined");
  file = file.substring(4);
  var fm_end = file.indexOf("+++");
  var obj = new Page;
  obj.origFile = contentDir+articleName+'.md';
  obj.file = articleName.replace("articles","clanek");
  obj.content = file.substring(fm_end+4);
  try {
    obj.metadata = toml.parse(file.substring(0,fm_end-1)+"\n");
  } catch(e) {
    console.log(articleName+": Failed to parse metadata");
    throw e;
  }
  if(obj.metadata.date && obj.metadata.date.creation) obj.metadata.date.creation = moment(obj.metadata.date.creation);
  return obj;
}
module.exports = function(_contentDir) {
  var exports = this;
  exports.walk = walk;
  exports.fancyname = "loader hugo";
  var contentDir = _contentDir;
  if(contentDir == undefined) contentDir = './content/';
  if(!contentDir.endsWith('/')) contentDir+='/';

  /*
   * articleName:
   *   string
   * callback:
   *   called when article is read
   * returns:
   *   {
   *     string articleName,content
   *     object frontmatter
   *     function save
   *   }
   */
  exports.readPage = function(articleName, cb) {
    fs.readFile(contentDir+articleName+".md", 'utf8', function(err, data) {
      if(err != null) throw err;
      cb(readPageWorker(data, articleName, contentDir));
    });
  }

  /*
   * callback:
   *     function(articleName)
   *     called for each article on website
   * cb_end:
   *     function()
   *     called when all articles are listed
   */
  exports.forEachPage = function(callback, cb_end) {
    walk(contentDir+"articles",function(filePath, stat) {
      if(callback !== undefined) callback(filePath.substring(contentDir.length,filePath.length-3));
    }, function() {
      if(cb_end !== undefined) cb_end();
    });
  };

  /*
   * cb:
   *    function(articleList)
   *    called after all cb_on_each
   */
  exports.getPageList = function(cb) {
    var currentlyReadingCount = 0;
    var allPagesListed = false;
    var cb_called = false;
    var list = new PageList;

    exports.forEachPage(function(articleName) {
      currentlyReadingCount++;
      exports.readPage(articleName, function(article){
        list.addPage(article);
        currentlyReadingCount--;
        if(allPagesListed && currentlyReadingCount == 0 && !cb_called) {
          if(cb !== undefined) cb(list);
          cb_called = true;
        }
      });
    },function(){
      if(currentlyReadingCount == 0 && !cb_called) {
        if(cb !== undefined) cb(list);
        cb_called = true;
      }
      allPagesListed = true;
    });
  };
}
